CON
  TableSize = 250

VAR
  
  ' Holds the value the output should take at each instant in time.
  long pwm_state[TableSize]
  long cogStack[20]

PUB Start
  dira[15] := 0 
  SetPWM(9,5)                  ' initialize the table
  SetPWM(10,0)                  
  SetPWM(16,10)      
  cognew (pwm_loop,cogStack)
PRI pwm_loop | t
  ' start the time value at zero
  ' PWM Loop
  dira[9] := 1                  ' Make pin 0, pin 1, and pin 2 all outputs
  dira[10] := 1
  dira[16] := 1
  dira[11] := 1

  t := 0
  repeat
    outa := pwm_state[t]       ' Set states of all 3 pwm pins simultaneously
    t+ = 1                      ' Change to the next state
    if t == TableSize           ' If t goes off the edge of the table  NOTE change
      t := 0                    ' start over at beginning

PUB SetPWM(pin, percent) | i, count

  ' Determine how many pixels to turn on for any table size
  count := (percent * TableSize) / 100
  
  repeat i from 0 to 100 - 1
    if i < count
      pwm_state[i] |= (1 << pin)
    else
      pwm_state[i] &= !(1 << pin)
                  